"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const internals_1 = require("../internals");
function empty(mutable, compare) {
    if (typeof mutable === 'function') {
        compare = mutable;
        mutable = false;
    }
    return internals_1.createTree(mutable || false, compare);
}
exports.empty = empty;
/**
 * Determines whether the input argument is an instance of a Collectable.js RedBlackTree structure.
 *
 * @export
 * @param {RedBlackTree<K, V>} arg The input value to check
 * @returns {boolean} True if the input value is a RedBlackTree, otherwise false
 */
function isRedBlackTree(arg) {
    return internals_1.isRedBlackTree(arg);
}
exports.isRedBlackTree = isRedBlackTree;

//# sourceMappingURL=empty.js.map
