"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
;
exports.NONE = {
    _group: 0,
    key: void 0,
    value: void 0,
    _red: false,
    _left: void 0,
    _right: void 0,
    _count: 0
};
exports.NONE._left = exports.NONE;
exports.NONE._right = exports.NONE;
function createNode(group, red, key, value) {
    return { _group: group, key, value, _red: red, _left: exports.NONE, _right: exports.NONE, _count: 1 };
}
exports.createNode = createNode;
function cloneNode(group, node) {
    return {
        _group: group,
        key: node.key,
        value: node.value,
        _red: node._red,
        _left: node._left,
        _right: node._right,
        _count: node._count
    };
}
exports.cloneNode = cloneNode;
function isNone(node) {
    return node === exports.NONE;
}
exports.isNone = isNone;
function editable(group, node) {
    return isNone(node) || node._group === group ? node : cloneNode(group, node);
}
exports.editable = editable;
function editRightChild(group, node) {
    var child = node._right;
    return isNone(child) || child._group === group ? child
        : (node._right = (child = cloneNode(group, child)), child);
}
exports.editRightChild = editRightChild;
function editLeftChild(group, node) {
    var child = node._left;
    return isNone(child) || child._group === group ? child
        : (node._left = (child = cloneNode(group, child)), child);
}
exports.editLeftChild = editLeftChild;
function assignValue(value, node) {
    const v = node.value;
    // Note the double-equals below is used to correctly compare Symbol() with Object(Symbol())
    if (v === value || (v !== null && typeof v === 'object' && v == value)) {
        return false;
    }
    node.value = value;
    return true;
}
exports.assignValue = assignValue;

//# sourceMappingURL=node.js.map
