import { RedBlackTree } from '../internals';
/**
 * Returns a copy of a tree, preserving the mutable/immutable status of the input tree.
 *
 * @export
 * @template K The type of keys in the tree
 * @template V The type of values in the tree
 * @param {RedBlackTree<K, V>} tree The tree to be cloned
 * @returns {RedBlackTree<K, V>} A cloned instance of the input tree
 */
export declare function clone<K, V>(tree: RedBlackTree<K, V>): RedBlackTree<K, V>;
